# Exercicio 1. Estimar por MC o sesgo, varianza e ECM da media mostral e
# de Q2 como estimadores da media e mediana nunha N(0,1), a partir de n=50
# e M=100 réplicas de MC.

#--------------------------------------------------------#
n<-50
M<-100
media<-0
mediana<-0
vmedia<-numeric(M)
vmediana<-numeric(M)

for(m in 1:M){
x<-rnorm(n)
vmedia[m]<-mean(x)
vmediana[m]<-median(x)
}

#-- Sesgo
SesgoMC_media<-mean(vmedia) #-media
SesgoMC_mediana<-mean(vmediana) #-mediana
SesgoMC_media
SesgoMC_mediana

#-- Varianza
VarMC_media<-mean(vmedia^2)-(mean(vmedia))^2
VarMC_mediana<-mean(vmediana^2)-(mean(vmediana))^2
VarMC_media
VarMC_mediana

#--- ECM
ECMMC_media<-SesgoMC_media^2+VarMC_media
ECMMC_mediana<-SesgoMC_mediana^2+VarMC_mediana
ECMMC_media
ECMMC_mediana

#--- Distribución
par(mfrow=c(1,2))
hist(vmedia,freq=F,main="media")
hist(vmediana,freq=F,main="mediana")


#------------------------------------------------------#
# Exercicio 2. Estimar o sesgo, varianza e ECM da media mostral e de Q2 como
#estimadores de E(X) e Me, a partir dunha mostra de n=50, con B=500.
#------------------------------------------------------#

n<-50
B<-500
x<-rnorm(n)
media<-mean(x)
mediana<-median(x)
media
mediana
MB<-matrix(0,nrow=B,ncol=n)

for (b in 1:B){
xb<-sample(x,size=n,replace=TRUE)
MB[b,]<-xb
}
vmediaB<-apply(MB,1,"mean")
vmedianaB<-apply(MB,1,"median")

#-- Sesgo
SesgoB_media<-mean(vmediaB)-media
SesgoB_mediana<-mean(vmedianaB)-mediana
SesgoB_media
SesgoB_mediana

#-- Varianza
VarB_media<-mean(vmediaB^2)-(mean(vmediaB))^2
VarB_mediana<-mean(vmedianaB^2)-(mean(vmedianaB))^2
VarB_media
VarB_mediana

#-- ECM
ECMB_media<-SesgoB_media^2+VarB_media
ECMB_mediana<-SesgoB_mediana^2+VarB_mediana
ECMB_media
ECMB_mediana


par(mfrow=c(2,2))
hist(vmedia,freq=F,main="media")
hist(vmediana,freq=F,main="mediana")
hist(vmediaB,freq=F,main="mediaB")
hist(vmedianaB,freq=F,main="medianaB")
